// update idle motion

function updateWorld(){
	CycleState=1;
	//IF SOUND IS TURNED ON, CHECK THE STATE OF THE ENGINE SOUND
	if(SoundSettings==1)CheckEngineSound();

	//IF A MOVEMENT STATE IS ACTIVE, THEN EXECUTE IT
	if(activeleft && !activeright)turnLeft();
	if(activeright && !activeleft)turnRight();
	if(activeforward && !activeback)moveForward(currentspeed);
	if(activeback && !activeforward)moveBackward(currentspeed);

	if(currentspeed == 0)moveForward(currentspeed);
	checkDust();

	//SPEED DAMPER
	if(currentspeed != 0 && (activeforward == activeback) ){ // Not accelerating or decelerating

	//DAMP FORWARD MOTION		
		if(currentspeed > 0 && (rearcontact || frontcontact)){
			currentspeed-=.05;
			moveBackward(currentspeed);
			}
		else if(currentspeed > 0 && !rearcontact && !frontcontact){
			currentspeed-=.025;
			moveBackward(currentspeed);
			}

	//DAMP BACKWARD MOTION		
		if(currentspeed < 0 && (rearcontact || frontcontact)){
			currentspeed+=.05;
			moveForward(currentspeed,2);
			}
		else if(currentspeed < 0 && !rearcontact && !frontcontact){
			currentspeed+=.025;
			moveForward(currentspeed,2);
			}

		if(currentspeed < .1 && currentspeed > -.1)currentspeed=0;
		}

	//AXLE DAMPER

	if((activeleft == activeright) && axleangle !=0){ // Not trying to turn left or right

		if(axleangle > 0){
			axleangle-=2.5;
			orientYAxis(RRT,axleangle/5);
			orientYAxis(RLT,axleangle/5);
			orientYAxis(FRT,-1*axleangle);
			orientYAxis(FLT,-1*axleangle);
			orientYAxis(ViewYaw,axleangle/10);
			}
		if(axleangle < 0){
			axleangle+=2.5;
			orientYAxis(RRT,axleangle/5);
			orientYAxis(RLT,axleangle/5);
			orientYAxis(FRT,-1*axleangle);
			orientYAxis(FLT,-1*axleangle);
			orientYAxis(ViewYaw,axleangle/10);
			}

		if(axleangle < 1.5 && axleangle > -1.5 && skidstate){
			skidstate=0;
			}

		}

		// UPDATE THE CHASE CAMERA		
		updateChaseCam();
	
		// MAKE BRAKELIGHTS FACE CAMERA

		LookTowardFreeBL();
	CycleState=0;
}

function updateChaseCam(){
	var camVector,posVector,camHeight,viewYawHeight;
		
	//CHECK TO ENSURE THAT THE CAM IS ABOVE GROUND IF CHASE CAM IS ON
	if(currentView!=6){

		if ( ver4012 ) // Old API
		{
			camVector = MTCamMove.getPosition();
			posVector = ViewCam.getPosition();
		}
		else
		{
			camVector = MTCamMove.getAbsolutePosition();
			posVector = ViewCam.getAbsolutePosition();
		}
		
		camHeight = getTerrainHeight(camVector.getX(), camVector.getZ());

		viewYawHeight=(camHeight-posVector.getY());
		if(currentView==1){
			if(currentspeed>0){
					MTCamMove.setPosition(0,1.5+viewYawHeight,((currentspeed/-2)-2.5));		
			}
			else{
					MTCamMove.setPosition(0,1.5+viewYawHeight,-2.5)		
			}
		}
	}
}


// Turn Right

function turnRight(){

	axleangle+=3.5;

	if(axleangle >= 30) {axleangle= 30}

	orientYAxis(RRT,axleangle/5);
	orientYAxis(RLT,axleangle/5);
	orientYAxis(FRT,-1*axleangle);
	orientYAxis(FLT,-1*axleangle);
	orientYAxis(ViewYaw,axleangle/10);

	if((currentspeed > 3 || currentspeed < -3)&& !skidstate && rearcontact && frontcontact){
		setTimeout('skidstate=0',7000);		
		playSound(skid,0);		
		skidstate=1;
		}


}

function turnLeft(){

	axleangle-=3.5;

	if(axleangle < -30) {axleangle= -30}

	orientYAxis(RRT,axleangle/5);
	orientYAxis(RLT,axleangle/5);
	orientYAxis(FRT,-1*axleangle);
	orientYAxis(FLT,-1*axleangle);
	orientYAxis(ViewYaw,axleangle/10);

	if((currentspeed > 3 || currentspeed < -3)&& !skidstate && rearcontact && frontcontact){
		setTimeout('skidstate=0',7000);		
		playSound(skid,0);		
		skidstate=1;
		}


}

function getTerrainHeight(xPosition,yPosition){
	var testMapX,testMapY,returnHeight,testHeight1,testHeight2,testLX,testLZ,side;

	yPosition=256-yPosition;

	testMapX=Math.round((xPosition)/mapScale);
	if(testMapX > xPosition/mapScale) {testMapX--}
	var testMapY=Math.round((yPosition)/mapScale);
	if(testMapY > yPosition/mapScale) {testMapY--}
	//if ( testMapX > 62 ) testMapX = 62;
	//if ( testMapY > 62 ) testMapY = 62;
	//if ( testMapX < 0 ) testMapX = 0;
	//if ( testMapY < 0 ) testMapY = 0;
	
	testLX = ((xPosition)/mapScale) - testMapX;
	testLZ = ((yPosition)/mapScale) - testMapY;

	side=radToDegree(Math.atan(testLZ/testLX));
	if(side > 45){	
		testHeight1 = map[testMapX][testMapY] + (map[testMapX][testMapY+1] - map[testMapX][testMapY])*testLZ;
		testHeight2 = map[testMapX+1][testMapY+1] - (map[testMapX][testMapY+1] - map[testMapX][testMapY]) + (map[testMapX][testMapY+1] - map[testMapX][testMapY])*testLZ;
		returnHeight = ((testHeight1 + (testHeight2 - testHeight1)*testLX)*2)+3.01;
	}
	else{
		testHeight2 = map[testMapX+1][testMapY] + (map[testMapX+1][testMapY+1] - map[testMapX+1][testMapY])*testLZ;
		testHeight1 = map[testMapX][testMapY] + (map[testMapX+1][testMapY+1] - map[testMapX+1][testMapY])*testLZ;
		returnHeight = ((testHeight1 + (testHeight2 - testHeight1)*testLX)*2)+3.01;
	}
	return returnHeight;
}


function moveForward(move){
		var fx, fz, oposx, oposy, oposz, rearx, rearz, frontx, frontz, dist;		
		var testx, testz, height1, height2, bottomheight, calcpitch;
		var roll1,roll2,midpoint,axleheightfront,axleheightrear,curroll1,curroll2;

		//CHECK BRAKELIGHTS AND DISPLAY THEM IF APPROPRIATE
		// Temporarily Disabled
		if(currentspeed <=0 && !brakelights && activeforward){
		      BLLC.setPosition(-.4, .4, -1.15);
		      BLRC.setPosition(.4, .4, -1.15);
			brakelights=1;
			}
		else if(currentspeed >0 && brakelights && !activeback){
			BLLC.setPosition(0,.2,0);
			BLRC.setPosition(0,.2,0);
			brakelights=0;
			}

		dist = move*.1;

		// CALCULATE THE CURRENT FORWARD MOVEMENT VECTOR

		fx = (Math.cos(pi/2 - degreeToRad(angle)) );
		fz = (Math.sin(pi/2 - degreeToRad(angle)) ); 

		// SAVE THE LAST POSITION		
		oposx = posx;
		oposy = posy;
		oposz = posz;
				
		// CALCULATE THE DISTANCE TRAVELED ALONG THE CURRENT VECTOR
		posx=posx+(fx*dist);
		posz=posz+(fz*dist);

		// CALCULATE THE AXLE POINTS AT THE FRONT AND REAR OF THE TRUCK
		rearx=posx+(fx*-1.1);
		rearz=posz+(fz*-1.1);

		frontx=posx+(fx*.9);
		frontz=posz+(fz*.9);


		// VERY ROUGH BOUNDS CHECKING - KEEP THE TRUCK INSIDE THE ARENA

		if (posx < 10){
			posx=10;
			}
		if (posx > 245){
			posx=245;
			}
		if (posz < 10){
			posz=10;
			}
		if (posz > 245){
			posz=245;
			}


		// SPIN THE WHEELS ACCORDING TO THE CURRENT SPEED
			wheelangle+=currentspeed*10;
			orientXAxis(FLW,1*wheelangle);
			orientXAxis(FRW,1*wheelangle);
			orientXAxis(RLW,1*wheelangle);
			orientXAxis(RRW,1*wheelangle);

		// FOLLOW THE TURN OF THE AXLE IF IN CONTACT WITH THE GROUND
			if((rearcontact || frontcontact) && currentspeed > 0){
				angle+=(axleangle/(-50/currentspeed));
				orientYAxis(ViewCamRot,angle);
				orientYAxis(Shadow,angle);	
				}					
			else if(!rearcontact && !frontcontact && currentspeed > 0){
				angle+=(savedaxleangle/(-50/currentspeed))/(airbornerear*20+1);
				orientYAxis(ViewCamRot,angle);
				orientYAxis(Shadow,angle);	
				}
			if((frontcontact || rearcontact) && currentspeed < 0){
				truckangle+=(axleangle/(-50/currentspeed));
				angle+=(axleangle/(-50/currentspeed));
				orientYAxis(ViewCamRot,angle);
				orientYAxis(Shadow,angle);	
			}					
			else if(!rearcontact && !frontcontact && currentspeed < 0){
				truckangle+=(savedaxleangle/(-50/currentspeed))/(airbornerear*20+10);
				angle+=(savedaxleangle/(-50/currentspeed))/(airbornerear*20+10);
				orientYAxis(ViewCamRot,angle);
				orientYAxis(Shadow,angle);	
				}


		// ASSUME THE WHEELS ARE NOT IN CONTACT WITH THE GROUND
		rearcontact=0;
		frontcontact=0;

		// BEGIN WITH THE FRONT AXLE

		// CALCULATE A POINT PERPINDICULAR TO CURRENT VECTOR FOR THE FRONT RIGHT TIRE

		fx = (Math.cos(pi/2 - degreeToRad(angle+90)));
		fz = (Math.sin(pi/2 - degreeToRad(angle+90))); 

		testx=frontx+(fx*.5);
		testz=frontz+(fz*.5);

		// CHECK THE TERRAIN HEIGHT AT THIS LOCATION
            height1=getTerrainHeight(testx,testz);
		

		// SEE IF THE WHEEL IS ABOVE OR BELOW THE GROUND

		// IF THE WHEEL IS ABOVE THE GROUND, LET'S START DROPPING IT
		if(wheelheightfr < height1){
			wheelheightfr=height1;
			frontcontact=1;
			airbornetimefrontr=0;
			}
		else{
			if(airbornetimefrontr==0){
				airbornetimefrontr=1;
				airbornefrontr=.07;
				savedaxleangle=axleangle;
				}
			else{
				airbornefrontr+=.01;
				}


			wheelheightfr = (wheelheightfr-(gravity*(airbornefrontr*airbornefrontr)));

			// IF THE WHEEL IS BELOW THE GROUND, SET IT BACK ON TOP OF IT
			if(wheelheightfr < height1){
				airbornetimefrontr=0;
				wheelheightfr=height1;
				frontcontact=1;
				// PLAY CREAK SOUND IF WE HIT
				if(airbornefrontr>=.1)playSound(creakfront,0);

				}
			}

		// CALCULATE A POINT PERPINDICULAR TO CURRENT VECTOR FOR THE FRONT LEFT TIRE

		fx = (Math.cos(pi/2 - degreeToRad(angle-90)));
		fz = (Math.sin(pi/2 - degreeToRad(angle-90))); 

		testx=frontx+(fx*.5);
		testz=frontz+(fz*.5);

		// CHECK THE TERRAIN HEIGHT AT THIS LOCATION
            height2=getTerrainHeight(testx,testz);

		// SEE IF THE WHEEL IS ABOVE OR BELOW THE GROUND

		// IF THE WHEEL IS ABOVE THE GROUND, LET'S START DROPPING IT

		if(wheelheightfl < height2){
			wheelheightfl=height2;
			frontcontact=1;
			airbornetimefrontl=0;
			}
		else{
			if(airbornetimefrontl==0){
				airbornetimefrontl=1;
				airbornefrontl=.07;
				savedaxleangle=axleangle;
				}
			else{
				airbornefrontl+=.01;
				}

			wheelheightfl = (wheelheightfl-(gravity*(airbornefrontl*airbornefrontl)));

			// IF THE WHEEL IS BELOW THE GROUND, SET IT BACK ON TOP OF IT

			if(wheelheightfl < height2){
				airbornetimefrontl=0;
				wheelheightfl=height2;
				frontcontact=1;
				// PLAY CREAK SOUND IF WE HIT
				if(airbornefrontl>=.1)playSound(creakfront,0);
				}
			}

		// IF NEITHER TIRE IS IN CONTACT WITH THE GROUND, SLOWLY EVEN THEM OUT
		if(!frontcontact){
				wheelheightfl+=((wheelheightfr-wheelheightfl)/20);
				wheelheightfr+=((wheelheightfl-wheelheightfr)/20);
			}

		// CALCULATE THE ROLL OF THE AXLE BASED UPON THE HEIGHTS OF THE TWO TIRES
		roll1=Math.asin(1/(Math.sqrt((wheelheightfl-wheelheightfr)*(wheelheightfl-wheelheightfr)+(1))));
		axleheightfront = (wheelheightfr+wheelheightfl)/2;

		curroll1 = radToDegree(roll1)-90;
		if(wheelheightfr > wheelheightfl) curroll1*=-1;
		
		// SET THE AXLE TO THE CALCULATED ROLL
		orientZAxis(FSuspensionRoll,curroll1);


		// NOW WE CHECK THE REAR AXLE

		// CALCULATE A POINT PERPINDICULAR TO CURRENT VECTOR FOR THE REAR RIGHT TIRE

		fx = (Math.cos(pi/2 - degreeToRad(angle+90)));
		fz = (Math.sin(pi/2 - degreeToRad(angle+90))); 

		testx=rearx+(fx*.5);
		testz=rearz+(fz*.5);

		// GET THE HEIGHT OF THE TERRAIN HERE
        height1=getTerrainHeight(testx,testz);

		// GENERATE A DUST CLOUD AT THE WHEEL IF WE'RE MOVING FAST ENOUGH
		if(currentspeed > .05 && airbornetimerearr==0)startDust(testx,height1-.6,testz);

		// SEE IF THE WHEEL IS ABOVE OR BELOW THE GROUND

		// IF THE WHEEL IS ABOVE THE GROUND, LET'S START DROPPING IT

		if(wheelheightrr < height1){
			wheelheightrr=height1;
			rearcontact=1;
			airbornetimerearr=0;
			}
		else{
			if(airbornetimerearr==0){
				airbornetimerearr=1;
				airbornerearr=.07;
				savedaxleangle=axleangle;
				}
			else{
				airbornerearr+=.01;
				}

			wheelheightrr = (wheelheightrr-(gravity*(airbornerearr*airbornerearr)));

			// IF THE WHEEL IS BELOW THE GROUND, SET IT BACK ON TOP OF IT

			if(wheelheightrr < height1){
				airbornetimerearr=0;
				wheelheightrr=height1;
				rearcontact=1;
				// PLAY CREAK SOUND IF WE HIT
				if(airbornerearr>=.1)playSound(creakrear,0);
				}
			}
		
		// CALCULATE A POINT PERPINDICULAR TO CURRENT VECTOR FOR THE REAR LEFT TIRE
		fx = (Math.cos(pi/2 - degreeToRad(angle-90)));
		fz = (Math.sin(pi/2 - degreeToRad(angle-90))); 

		testx=rearx+(fx*.5);
		testz=rearz+(fz*.5);

		
            height2=getTerrainHeight(testx,testz);

		// GENERATE A DUST CLOUD AT THE WHEEL IF WE'RE MOVING FAST ENOUGH
		if(currentspeed > .05 && airbornetimerearl==0)startDust(testx,height2-.6,testz);

		// SEE IF THE WHEEL IS ABOVE OR BELOW THE GROUND

		// IF THE WHEEL IS ABOVE THE GROUND, LET'S START DROPPING IT

		if(wheelheightrl < height2){
			wheelheightrl=height2;
			airbornetimerearl=0;
			rearcontact=1;
			}
		else{
			if(airbornetimerearl==0){
				airbornetimerearl=1;
				airbornerearl=.07;
				savedaxleangle=axleangle;
				}
			else{
				airbornerearl+=.01;
				}

			wheelheightrl = (wheelheightrl-(gravity*(airbornerearl*airbornerearl)));
			if(wheelheightrl < height2){
				airbornetimerearl=0;
				wheelheightrl=height2;
				rearcontact=1;
				// PLAY CREAK SOUND IF WE HIT
				if(airbornerearl>=.1)playSound(creakrear,0);
				// IF WE'VE BEEN IN THE AIR LONG ENOUGH, PLAY SOME COMENTARY
				if(airbornerearl>.27 && !commentary){
					commentary=1;
					setTimeout('commentary=0',3000);
					}
				}
			}

		// IF NEITHER TIRE IS IN CONTACT WITH THE GROUND, SLOWLY EVEN THEM OUT
		if(!rearcontact){
				wheelheightrl+=((wheelheightrr-wheelheightrl)/20);
				wheelheightrr+=((wheelheightrl-wheelheightrr)/20);
			}

		// CALCULATE THE ROLL OF THE AXLE BASED UPON THE HEIGHTS OF THE TWO TIRES
		roll2=Math.asin(1/(Math.sqrt((wheelheightrl-wheelheightrr)*(wheelheightrl-wheelheightrr)+(1))));

		axleheightrear = (wheelheightrr+wheelheightrl)/2;
		curroll2 = radToDegree(roll2)-90;
		if(wheelheightrr > wheelheightrl) curroll2*=-1;
		
		// SET THE AXLE TO THE CALCULATED ROLL
		orientZAxis(RSuspensionRoll,curroll2);


		
		// FIND THE CENTER BETWEEN THE FRONT AND REAR AXLES - CALCULATE AN OBJECT CENTER
		midpoint=(axleheightrear+axleheightfront)/2;
		bottomheight=midpoint;
		// SET OUR TRUCK AT THAT POINT
		posy=midpoint;
		ViewCam.setPosition(posx, posy, posz);
	

		// ORIENT THE SUSPENSION BARS BENEATH THE TRUCK
		var calcpitch=Math.asin(1/Math.sqrt((bottomheight-axleheightfront)*(bottomheight-axleheightfront)+(1)));
		calcpitch = radToDegree(calcpitch)-90;
		if(axleheightfront > bottomheight) calcpitch*=-1;
		if(calcpitch > 0)calcpitch=0;
		if(calcpitch < -30)calcpitch=-30;

		orientXAxis(FSuspension,-calcpitch);

		calcpitch=Math.asin(1/Math.sqrt((axleheightrear-bottomheight)*(axleheightrear-bottomheight)+(1)));
		calcpitch = radToDegree(calcpitch)*-1+90;
		if(bottomheight > axleheightrear) calcpitch*=-1;
		if(calcpitch < 0)calcpitch=0;
		if(calcpitch > 30)calcpitch=30;

		orientXAxis(RSuspension,calcpitch);

		// POSITION THE SHADOW ON THE GROUND
            bottomheight=getTerrainHeight(posx,posz);
		Shadow.setPosition(posx, bottomheight-1, posz);
		
		//CALCULATE THE OVERALL PITCH OF THE TRUCK BASED ON THE AXLE HEIGHTS WE'VE CALCULATED

		pitch=Math.asin(1/Math.sqrt((axleheightrear-axleheightfront)*(axleheightrear-axleheightfront)+(1)));
		calcpitch = radToDegree(pitch)*-1+90;
		if(axleheightfront > axleheightrear){
			calcpitch*=-1;
			curpitch=calcpitch/12;	
		}
		else{
			curpitch = calcpitch/2;
			}

		// APPLY THE PITCH TO THE VARIOUS PORTIONS OF THE TRUCK, IN VARIOUS DEGREES
		orientXAxis(ViewPitch,calcpitch/2);
		orientXAxis(DriveShaft,curpitch);
		orientXAxis(BodyPitch,curpitch);
		TruckPitch=calcpitch/2;
		orientXAxis(BLLRS,-1*calcpitch/2);
		orientXAxis(BLRRS,-1*calcpitch/2);

		// CALCULATE AND APPLY THE ROLL OF THE TRUCK BASED UPON THE ROLL OF THE AXLES

		orientZAxis(BodyRoll,(curroll1+curroll2)/2);
		orientZAxis(ShadowRoll,(curroll1+curroll2)/2);

		// CHECK TO SEE IF WE SHOULD BE ROLLING DOWN A HILL

            height1=getTerrainHeight(rearx,rearz);
            height2=getTerrainHeight(frontx,frontz);

		pitch=Math.asin(1/Math.sqrt((height1-height2)*(height1-height2)+(1)));
		calcpitch = radToDegree(pitch)*-1+90;
		if(height2 < height1) calcpitch*=-1;

		// ORIENT THE SHADOW TO THIS LAY OF THE GROUND
		orientXAxis(ShadowPitch,calcpitch/-2);

		// IF BOTH WHEELS ARE ON THE GROUND, APPLY THE DOWNHILL ROLL
		if(rearcontact && frontcontact)currentspeed-=calcpitch/600;



		// IF WE'VE BEEN IN THE AIR LONG ENOUGH, COMMENT ON IT
		if(airbornerearr>=.3 && !commentary){
			commentary=1;
			setTimeout('commentary=0',2300);
			}

		if(activeforward){
			if(currentspeed <= MaxForwardSpeed && (rearcontact || frontcontact))currentspeed+=.055;
			if(currentspeed <= 0 && (rearcontact || frontcontact))currentspeed+=.15;
		}

}

function moveBackward(move){
		var fx, fz, oposx, oposy, oposz, rearx, rearz, frontx, frontz, dist;		
		var testx, testz, height1, height2, bottomheight, calcpitch;
		var roll1,roll2,midpoint,axleheightfront,axleheightrear,curroll1,curroll2;

		//CHECK BRAKELIGHTS AND DISPLAY THEM IF APPROPRIATE
		// Temporarily Disabled
		if(currentspeed >=0 && !brakelights && activeback){
		      BLLC.setPosition(-.4, .4, -1.15);
		      BLRC.setPosition(.4, .4, -1.15);
			brakelights=1;
			}
		else if(currentspeed < 0 && brakelights && !activeforward){
			BLLC.setPosition(0,.2,0);
			BLRC.setPosition(0,.2,0);
			brakelights=0;
			}
		

		dist = move*.1;

		// CALCULATE THE CURRENT FORWARD MOVEMENT VECTOR

		fx = (Math.cos(pi/2 - degreeToRad(angle)) );
		fz = (Math.sin(pi/2 - degreeToRad(angle)) ); 

		// SAVE THE LAST POSITION		
		oposx = posx;
		oposy = posy;
		oposz = posz;
				
		// CALCULATE THE DISTANCE TRAVELED ALONG THE CURRENT VECTOR
		posx=posx+(fx*dist);
		posz=posz+(fz*dist);

		// CALCULATE THE AXLE POINTS AT THE FRONT AND REAR OF THE TRUCK
		rearx=posx+(fx*-1.1);
		rearz=posz+(fz*-1.1);

		frontx=posx+(fx*.9);
		frontz=posz+(fz*.9);


		// VERY ROUGH BOUNDS CHECKING - KEEP THE TRUCK INSIDE THE ARENA

		if (posx < 10){
			posx=10;
			}
		if (posx > 245){
			posx=245;
			}
		if (posz < 10){
			posz=10;
			}
		if (posz > 245){
			posz=245;
			}


		// SPIN THE WHEELS ACCORDING TO THE CURRENT SPEED
			wheelangle+=currentspeed*10;
			orientXAxis(FLW,1*wheelangle);
			orientXAxis(FRW,1*wheelangle);
			orientXAxis(RLW,1*wheelangle);
			orientXAxis(RRW,1*wheelangle);

		// FOLLOW THE TURN OF THE AXLE IF IN CONTACT WITH THE GROUND
			if((rearcontact || frontcontact) && currentspeed > 0){
				angle+=(axleangle/(-50/currentspeed));
				orientYAxis(ViewCamRot,angle);
				orientYAxis(Shadow,angle);	
				}					
			else if(!rearcontact && !frontcontact && currentspeed > 0){
				angle+=(savedaxleangle/(-50/currentspeed))/(airbornerear*20+1);
				orientYAxis(ViewCamRot,angle);
				orientYAxis(Shadow,angle);	
				}
			if((frontcontact || rearcontact) && currentspeed < 0){
				truckangle+=(axleangle/(-50/currentspeed));
				angle+=(axleangle/(-50/currentspeed));
				orientYAxis(ViewCamRot,angle);
				orientYAxis(Shadow,angle);	
			}					
			else if(!rearcontact && !frontcontact && currentspeed < 0){
				truckangle+=(savedaxleangle/(-50/currentspeed))/(airbornerear*20+10);
				angle+=(savedaxleangle/(-50/currentspeed))/(airbornerear*20+10);
				orientYAxis(ViewCamRot,angle);
				orientYAxis(Shadow,angle);	
				}


		// ASSUME THE WHEELS ARE NOT IN CONTACT WITH THE GROUND
		rearcontact=0;
		frontcontact=0;

		// BEGIN WITH THE FRONT AXLE

		// CALCULATE A POINT PERPINDICULAR TO CURRENT VECTOR FOR THE FRONT RIGHT TIRE

		fx = (Math.cos(pi/2 - degreeToRad(angle+90)));
		fz = (Math.sin(pi/2 - degreeToRad(angle+90))); 

		testx=frontx+(fx*.5);
		testz=frontz+(fz*.5);

		// CHECK THE TERRAIN HEIGHT AT THIS LOCATION
            height1=getTerrainHeight(testx,testz);
		

		// SEE IF THE WHEEL IS ABOVE OR BELOW THE GROUND

		// IF THE WHEEL IS ABOVE THE GROUND, LET'S START DROPPING IT
		if(wheelheightfr < height1){
			wheelheightfr=height1;
			frontcontact=1;
			airbornetimefrontr=0;
			}
		else{
			if(airbornetimefrontr==0){
				airbornetimefrontr=1;
				airbornefrontr=.07;
				savedaxleangle=axleangle;
				}
			else{
				airbornefrontr+=.01;
				}


			wheelheightfr = (wheelheightfr-(gravity*(airbornefrontr*airbornefrontr)));

			// IF THE WHEEL IS BELOW THE GROUND, SET IT BACK ON TOP OF IT
			if(wheelheightfr < height1){
				airbornetimefrontr=0;
				wheelheightfr=height1;
				frontcontact=1;
				// PLAY CREAK SOUND IF WE HIT
				if(airbornefrontr>=.1)playSound(creakfront,0);

				}
			}

		// CALCULATE A POINT PERPINDICULAR TO CURRENT VECTOR FOR THE FRONT LEFT TIRE

		fx = (Math.cos(pi/2 - degreeToRad(angle-90)));
		fz = (Math.sin(pi/2 - degreeToRad(angle-90))); 

		testx=frontx+(fx*.5);
		testz=frontz+(fz*.5);

		// CHECK THE TERRAIN HEIGHT AT THIS LOCATION
            height2=getTerrainHeight(testx,testz);

		// SEE IF THE WHEEL IS ABOVE OR BELOW THE GROUND

		// IF THE WHEEL IS ABOVE THE GROUND, LET'S START DROPPING IT

		if(wheelheightfl < height2){
			wheelheightfl=height2;
			frontcontact=1;
			airbornetimefrontl=0;
			}
		else{
			if(airbornetimefrontl==0){
				airbornetimefrontl=1;
				airbornefrontl=.07;
				savedaxleangle=axleangle;
				}
			else{
				airbornefrontl+=.01;
				}

			wheelheightfl = (wheelheightfl-(gravity*(airbornefrontl*airbornefrontl)));

			// IF THE WHEEL IS BELOW THE GROUND, SET IT BACK ON TOP OF IT

			if(wheelheightfl < height2){
				airbornetimefrontl=0;
				wheelheightfl=height2;
				frontcontact=1;
				// PLAY CREAK SOUND IF WE HIT
				if(airbornefrontl>=.1)playSound(creakfront,0);
				}
			}

		// IF NEITHER TIRE IS IN CONTACT WITH THE GROUND, SLOWLY EVEN THEM OUT
		if(!frontcontact){
				wheelheightfl+=((wheelheightfr-wheelheightfl)/20);
				wheelheightfr+=((wheelheightfl-wheelheightfr)/20);
			}

		// CALCULATE THE ROLL OF THE AXLE BASED UPON THE HEIGHTS OF THE TWO TIRES
		roll1=Math.asin(1/(Math.sqrt((wheelheightfl-wheelheightfr)*(wheelheightfl-wheelheightfr)+(1))));
		axleheightfront = (wheelheightfr+wheelheightfl)/2;

		curroll1 = radToDegree(roll1)-90;
		if(wheelheightfr > wheelheightfl) curroll1*=-1;
		
		// SET THE AXLE TO THE CALCULATED ROLL
		orientZAxis(FSuspensionRoll,curroll1);


		// NOW WE CHECK THE REAR AXLE

		// CALCULATE A POINT PERPINDICULAR TO CURRENT VECTOR FOR THE REAR RIGHT TIRE

		fx = (Math.cos(pi/2 - degreeToRad(angle+90)));
		fz = (Math.sin(pi/2 - degreeToRad(angle+90))); 

		testx=rearx+(fx*.5);
		testz=rearz+(fz*.5);

		// GET THE HEIGHT OF THE TERRAIN HERE
        height1=getTerrainHeight(testx,testz);

		// GENERATE A DUST CLOUD AT THE WHEEL IF WE'RE MOVING FAST ENOUGH
		if(currentspeed < -.05 && airbornetimerearr==0)startDust(testx,height1-.6,testz);

		// SEE IF THE WHEEL IS ABOVE OR BELOW THE GROUND

		// IF THE WHEEL IS ABOVE THE GROUND, LET'S START DROPPING IT

		if(wheelheightrr < height1){
			wheelheightrr=height1;
			rearcontact=1;
			airbornetimerearr=0;
			}
		else{
			if(airbornetimerearr==0){
				airbornetimerearr=1;
				airbornerearr=.07;
				savedaxleangle=axleangle;
				}
			else{
				airbornerearr+=.01;
				}

			wheelheightrr = (wheelheightrr-(gravity*(airbornerearr*airbornerearr)));

			// IF THE WHEEL IS BELOW THE GROUND, SET IT BACK ON TOP OF IT

			if(wheelheightrr < height1){
				airbornetimerearr=0;
				wheelheightrr=height1;
				rearcontact=1;
				// PLAY CREAK SOUND IF WE HIT
				if(airbornerearr>=.1)playSound(creakrear,0);
				}
			}
		
		// CALCULATE A POINT PERPINDICULAR TO CURRENT VECTOR FOR THE REAR LEFT TIRE
		fx = (Math.cos(pi/2 - degreeToRad(angle-90)));
		fz = (Math.sin(pi/2 - degreeToRad(angle-90))); 

		testx=rearx+(fx*.5);
		testz=rearz+(fz*.5);

		
            height2=getTerrainHeight(testx,testz);

		// GENERATE A DUST CLOUD AT THE WHEEL IF WE'RE MOVING FAST ENOUGH
		if(currentspeed < -.05 && airbornetimerearl==0)startDust(testx,height2-.6,testz);

		// SEE IF THE WHEEL IS ABOVE OR BELOW THE GROUND

		// IF THE WHEEL IS ABOVE THE GROUND, LET'S START DROPPING IT

		if(wheelheightrl < height2){
			wheelheightrl=height2;
			airbornetimerearl=0;
			rearcontact=1;
			}
		else{
			if(airbornetimerearl==0){
				airbornetimerearl=1;
				airbornerearl=.07;
				savedaxleangle=axleangle;
				}
			else{
				airbornerearl+=.01;
				}

			wheelheightrl = (wheelheightrl-(gravity*(airbornerearl*airbornerearl)));
			if(wheelheightrl < height2){
				airbornetimerearl=0;
				wheelheightrl=height2;
				rearcontact=1;
				// PLAY CREAK SOUND IF WE HIT
				if(airbornerearl>=.1)playSound(creakrear,0);
				// IF WE'VE BEEN IN THE AIR LONG ENOUGH, PLAY SOME COMENTARY
				if(airbornerearl>.27 && !commentary){
					commentary=1;
					setTimeout('commentary=0',3000);
					}
				}
			}

		// IF NEITHER TIRE IS IN CONTACT WITH THE GROUND, SLOWLY EVEN THEM OUT
		if(!rearcontact){
				wheelheightrl+=((wheelheightrr-wheelheightrl)/20);
				wheelheightrr+=((wheelheightrl-wheelheightrr)/20);
			}

		// CALCULATE THE ROLL OF THE AXLE BASED UPON THE HEIGHTS OF THE TWO TIRES
		roll2=Math.asin(1/(Math.sqrt((wheelheightrl-wheelheightrr)*(wheelheightrl-wheelheightrr)+(1))));

		axleheightrear = (wheelheightrr+wheelheightrl)/2;
		curroll2 = radToDegree(roll2)-90;
		if(wheelheightrr > wheelheightrl) curroll2*=-1;
		
		// SET THE AXLE TO THE CALCULATED ROLL
		orientZAxis(RSuspensionRoll,curroll2);

		// FIND THE CENTER BETWEEN THE FRONT AND REAR AXLES - CALCULATE AN OBJECT CENTER
		midpoint=(axleheightrear+axleheightfront)/2;
		bottomheight=midpoint;
		// SET OUR TRUCK AT THAT POINT
		posy=midpoint;
		ViewCam.setPosition(posx, posy, posz);

		// ORIENT THE SUSPENSION BARS BENEATH THE TRUCK
		var calcpitch=Math.asin(1/Math.sqrt((bottomheight-axleheightfront)*(bottomheight-axleheightfront)+(1)));
		calcpitch = radToDegree(calcpitch)-90;
		if(axleheightfront > bottomheight) calcpitch*=-1;
		if(calcpitch > 0)calcpitch=0;
		if(calcpitch < -30)calcpitch=-30;

		orientXAxis(FSuspension,-calcpitch);

		calcpitch=Math.asin(1/Math.sqrt((axleheightrear-bottomheight)*(axleheightrear-bottomheight)+(1)));
		calcpitch = radToDegree(calcpitch)*-1+90;
		if(bottomheight > axleheightrear) calcpitch*=-1;
		if(calcpitch < 0)calcpitch=0;
		if(calcpitch > 30)calcpitch=30;

		orientXAxis(RSuspension,calcpitch);

		// POSITION THE SHADOW ON THE GROUND
            bottomheight=getTerrainHeight(posx,posz);
		Shadow.setPosition(posx, bottomheight-1, posz);
		
		//CALCULATE THE OVERALL PITCH OF THE TRUCK BASED ON THE AXLE HEIGHTS WE'VE CALCULATED

		pitch=Math.asin(1/Math.sqrt((axleheightrear-axleheightfront)*(axleheightrear-axleheightfront)+(1)));
		calcpitch = radToDegree(pitch)*-1+90;
		if(axleheightfront > axleheightrear){
			calcpitch*=-1;
			curpitch=calcpitch/12;	
		}
		else{
			curpitch = calcpitch/2;
			}

		// APPLY THE PITCH TO THE VARIOUS PORTIONS OF THE TRUCK, IN VARIOUS DEGREES
		orientXAxis(ViewPitch,calcpitch/2);
		orientXAxis(DriveShaft,curpitch);
		orientXAxis(BodyPitch,curpitch);
		TruckPitch=calcpitch/2;
		orientXAxis(BLLRS,-1*calcpitch/2);
		orientXAxis(BLRRS,-1*calcpitch/2);

		// CALCULATE AND APPLY THE ROLL OF THE TRUCK BASED UPON THE ROLL OF THE AXLES

		orientZAxis(BodyRoll,(curroll1+curroll2)/2);
		orientZAxis(ShadowRoll,(curroll1+curroll2)/2);

		// CHECK TO SEE IF WE SHOULD BE ROLLING DOWN A HILL

            height1=getTerrainHeight(rearx,rearz);
            height2=getTerrainHeight(frontx,frontz);

		pitch=Math.asin(1/Math.sqrt((height1-height2)*(height1-height2)+(1)));
		calcpitch = radToDegree(pitch)*-1+90;
		if(height2 < height1) calcpitch*=-1;

		// ORIENT THE SHADOW TO THIS LAY OF THE GROUND
		orientXAxis(ShadowPitch,calcpitch/-2);

		// IF BOTH WHEELS ARE ON THE GROUND, APPLY THE DOWNHILL ROLL
		if(rearcontact && frontcontact)currentspeed-=calcpitch/600;



		// IF WE'VE BEEN IN THE AIR LONG ENOUGH, COMMENT ON IT
		if(airbornerearr>=.3 && !commentary){
			commentary=1;
			setTimeout('commentary=0',2300);
			}

		if(activeback){
			if(currentspeed >= MaxBackwardSpeed && (rearcontact || frontcontact))currentspeed-=.055;
			if(currentspeed >= 0 && (rearcontact || frontcontact))currentspeed-=.1;
		}

}

